<?php
/****************************************************************************
 * DRBImageGallery
 * http://www.dbscripts.net/imagegallery/
 * 
 * Copyright (c) 2007-2009 Don Barnes 
 ****************************************************************************/
 
// Database configuration
//     Modify these settings to match your MySQL configuration.
//     Currently, only MySQL is supported.
$DB_HOST = 'localhost'; // database hostname
$DB_USERNAME = 'yourusername'; // database username
$DB_PASSWORD = 'yourpassword'; // database password
$DB_SCHEMA = 'yourdatabasename'; // database name

// Table name prefix
//     Change this if you would like the tables to be created 
//     with a different prefix.
$TABLE_PREFIX = "dbimg_";

// Table names (without prefix)
//     You can change the table names if you like, though this 
//     shouldn't be necessary.
$TABLE_IMAGE = "Image";
$TABLE_ATTRIBUTE = "Attribute";
$TABLE_ATTRIBUTE_VALUE = "AttributeValue";
$TABLE_IMAGE_ATTRIBUTE_VALUE = "ImageAttributeValue";

// Field max lengths
//     If these lengths need to be increased, this must be done before   
//     running the install script.
//     These values cannot be increased after the install script has been run,
//     because they are used as the column lengths in the corresponding table 
//     create statements.
$MAX_IMAGE_DESCRIPTION_LENGTH = 4095;

//	   NOTE: The following must be <= 255 if using a MySQL version prior to 5.0.3
$MAX_IMAGE_FILENAME_LENGTH = 255;
$MAX_IMAGE_NAME_LENGTH = 127;
$MAX_ATTRIBUTE_NAME_LENGTH = 127;
$MAX_ATTRIBUTE_VALUE_LENGTH = 127;

// Template Name
//     Corresponds to the name of a subfolder under the "template" subfolder 
//     containing a valid HTML/XHTML template.
$TEMPLATE_NAME = "default";

// Site Name
//     Change this to the name of your site.
$SITE_TITLE = "Image Gallery";

// Admin login configuration
//     Change this to whatever you want the admin login to be.
$ADMIN_USERNAME = "admin";
$ADMIN_PASSWORD = "password";

// Images
//     Put your images in this subfolder, and use the scan option on the 
//     administration panel to import them into the database.
$IMAGE_FOLDER = "images";

// Admin

//     Name of the subfolder where the administration panel is located.
//     Change this if you decide to rename the admin folder.
$ADMIN_FOLDER = "admin";

//     Prevents changes through the Administration Panel.
$READ_ONLY_MODE = FALSE;

//     Maximum size (in bytes) of uploaded images
$MAX_IMAGE_FILE_SIZE = 4000000;

// Thumbnails
//     The application can generate thumbnail images when the image records 
//     are created.  Otherwise, the original image is used in search results.
//     GD library is required for thumbnails support.  
//     Currently, only jpg, gif, and png files are supported.
$CREATE_THUMBS = TRUE;
$MAX_THUMB_WIDTH = 125;
$MAX_THUMB_HEIGHT = 100;
$THUMB_QUALITY = 75;	// Thumbnail quality (0-100)
$THUMB_FOLDER = "thumbs";	// Folder where thumbnail images will be created

// Search
//     Control whether the name or description fields are displayed in the
//     search form.
$ALLOW_SEARCH_BY_NAME = TRUE;
$ALLOW_SEARCH_BY_DESCRIPTION = TRUE;

// Results

//     Max results per page.
$MAX_RESULTS_PER_PAGE = 12;

//     Whether to show first and last buttons on results.
$SHOW_FIRST_AND_LAST_BUTTONS = TRUE;

//     Whether clicking on an image in the results
//     opens a page with the name and description.  
//     If set to false, the results will link 
//     directly to the image itself instead.
$LINK_RESULTS_TO_PAGE = TRUE;

?>
